
# Upstream: Dag Wieers <dag@wieers.com>
# OurDelta: Steve Walsh <steve@nerdvana.org.au> & Arjen Lentz <arjen@openquery.com.au>

%{?dist: %{expand: %%define %dist 1}}

Summary: Ourdelta repo release file and package configuration
Name: OurDelta-release
Version: 0.0.4
Release: 1
License: GPL
Group: System Environment/Base
Vendor: OurDelta
URL: http://ourdelta.org/

Source0: mirrors-OurDelta 
Source1: RPM-GPG-KEY-OurDelta
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
ourdelta.org release file. This package contains yum configuration for the ourdelta.org MySQL repo, as well as the public GPG keys used to sign them.

%prep
%setup -c

%{?el5:name='Red Hat Enterprise'; version='5'; path="redhat/el"; builder='stevewalsh'}
%{?el4:name='Red Hat Enterprise'; version='4'; path="redhat/el"; builder='stevewalsh'}

### Yum needs hardcoded version as on RHEL4AS releasever translates to 4AS :(
%{__cat} <<EOF >OurDelta.yum
[ourdelta]
name= OurDelta MySQL packages
mirrorlist = http://mirror.ourdelta.org/yum/CentOS/mirrors-OurDelta
baseurl = http://mirror.ourdelta.org/yum/CentOS/\$releasever
#mirrorlist = /etc/yum.repos.d/mirrors-OurDelta
enabled=1
gpgcheck=1
protect=1
gpgkey = file:///etc/pki/rpm-gpg/RPM-GPG-KEY-OurDelta
EOF

for mirror in $(%{__cat} %{SOURCE0}); do
	echo "$mirror"
done >mirrors-OurDelta.yum

%build

%install
%{__rm} -rf %{buildroot}
%{__cp} -a %{SOURCE1} .
%{__install} -Dp -m0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-OurDelta
%{__install} -Dp -m0644 OurDelta.yum %{buildroot}%{_sysconfdir}/yum.repos.d/OurDelta.repo
%{__install} -Dp -m0644 mirrors-OurDelta.yum %{buildroot}%{_sysconfdir}/yum.repos.d/mirrors-OurDelta

%clean
%{__rm} -rf %{buildroot}

%post

%files
%defattr(-, root, root, 0755)
%doc OurDelta.yum RPM-GPG-KEY-OurDelta* OurDelta.*
%if %{!?_without_rpmpubkey:1}0
%pubkey RPM-GPG-KEY-OurDelta
%endif
%config(noreplace) %{_sysconfdir}/yum.repos.d/OurDelta.repo
%config %{_sysconfdir}/yum.repos.d/mirrors-OurDelta
%dir %{_sysconfdir}/pki/rpm-gpg/
%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-OurDelta*
