# OurDelta RPM SPEC for MySQL 5.0 builds on CentOS 4/5
# 2008-10-05 arjen@openquery.com Initial foo
# 2008-11-04 arjen@openquery.com Updated patch/build process
# 2009-03-24 arjen@openquery.com Fixups for 5.0.77, and now 4/7 not 4_6/5_2
# 2009-09-26 arjen@openquery.com Fixups for 5.0.86

# rpmbuild -ba mysql-ourdelta-centos.spec --sign --define 'ourdelta 1'
# rpmbuild -ba mysql-ourdelta-centos.spec --sign --define 'ourdeltasail 1'
#       --define '_with_yassl 1'
#       --define 'mysqlversion 5.0.67'
#       --define 'elversion 4'        or      --define 'elversion 5'
#	--define 'patchset d5'
#	--define 'buildrev 0'
#
%define mysql_packager	OurDelta - http://ourdelta.org/

%define extversion      %{mysqlversion}.%{patchset}
%define distribution	el%{elversion}
%define release		%{buildrev}.%{distribution}

# Meta information


# use "rpmbuild --with yassl" or "rpm --define '_with_yassl 1'" (for RPM 3.x)
# to build with yaSSL support (off by default)
%{?_with_yassl:%define YASSL_BUILD 1}
%{!?_with_yassl:%define YASSL_BUILD 0}

#
# Product definitions - one of these has to be defined via the RPM build
# options, e.g. "--define 'ourdelta 1'"
#
%{!?ourdelta:%define ourdelta 0}
%{!?ourdeltasail:%define ourdeltasail 0}

# On SuSE 9 no separate "debuginfo" package is built. To enable basic
# debugging on that platform, we don't strip binaries on SuSE 9. We
# disable the strip of binaries by redefining the RPM macro
# "__os_install_post" leaving out the script calls that normally does
# this. We do this in all cases, as on platforms where "debuginfo" is
# created, a script "find-debuginfo.sh" will be called that will do
# the strip anyway, part of separating the executable and debug
# information into separate files put into separate packages.
#
# Some references (shows more advanced conditional usage):
# http://www.redhat.com/archives/rpm-list/2001-November/msg00257.html
# http://www.redhat.com/archives/rpm-list/2003-February/msg00275.html
# http://www.redhat.com/archives/rhl-devel-list/2004-January/msg01546.html
# http://lists.opensuse.org/archive/opensuse-commit/2006-May/1171.html

%define __os_install_post /usr/lib/rpm/brp-compress

# (comment) parentheses get added later as we might suffix "- Debug" also
%define comment %{mysql_packager}

%if %{ourdelta}
%define mysql_basename	MySQL-OurDelta
%define server_suffix	.%{patchset}-ourdelta
%define upstream_source mysql-%{mysqlversion}-%{patchset}-ourdelta
%endif

%if %{ourdeltasail}
%define mysql_basename	MySQL-OurDelta-Sail
%define server_suffix	.%{patchset}-ourdelta-sail
%define upstream_source mysql-%{mysqlversion}-%{patchset}-ourdelta-sail
%endif


%define mysqld_user		mysql
%define mysqld_group	mysql
%define mysqldatadir	/var/lib/mysql

# We don't package all files installed into the build root by intention -
# See BUG#998 for details.
%define _unpackaged_files_terminate_build 0

%define see_base For a description of MySQL see the base MySQL RPM
Source0:		%{upstream_source}.tar.gz

Name:		%{mysql_basename}
Summary:	MySQL: a very fast and reliable SQL database server
Group:		Applications/Databases
Version:	%{extversion}
Release:	%{release}
Distribution:	%{distribution}
License:	GPL
Source:		%{upstream_source}.tar.gz
URL:		http://ourdelta.org/
Packager:	%{mysql_packager}
Vendor:		%{mysql_packager}
Provides:	msqlormysql MySQL-server mysql
BuildRequires:  gperf perl readline-devel gcc-c++ ncurses-devel zlib-devel libtool automake autoconf time

# Think about what you use here since the first step is to
# run a rm -rf
BuildRoot:    %{_tmppath}/%{name}-%{extversion}-build

%description
The MySQL(R) software delivers a very fast, multi-threaded, multi-user,
and robust SQL (Structured Query Language) database server.
MySQL is a registered trademark of Sun Microsystems.

The MySQL software is GPL v2 licensed, which means you can use the it free
of charge under the conditions of the GNU General Public License Version 2
(http://www.gnu.org/licenses/).

OurDelta builds with a number of enhancements to the base MySQL code.
See the OurDelta website (http://ourdelta.org/) for info, sources and news.
You can also find various companies there that provide MySQL-related
services such as training, architecture assistance, and performance tuning.

%package -n %{mysql_basename}-server
Summary:	%{mysql_basename} for %{distribution}
Group:		Applications/Databases
Requires: chkconfig coreutils shadow-utils grep procps
Provides:	msqlormysql mysql-server mysql MySQL MySQL-server
Obsoletes:	MySQL mysql mysql-server MySQL-server

%description -n %{mysql_basename}-server
The MySQL(R) software delivers a very fast, multi-threaded, multi-user,
and robust SQL (Structured Query Language) database server.
MySQL is a registered trademark of Sun Microsystems.

The MySQL software is GPL v2 licensed, which means you can use the it free
of charge under the conditions of the GNU General Public License Version 2
(http://www.gnu.org/licenses/).

OurDelta builds with a number of enhancements to the base MySQL code.
See the OurDelta website (http://ourdelta.org/) for info, sources and news.
You can also find various companies there that provide MySQL-related
services such as training, architecture assistance, and performance tuning.

This package includes the MySQL server binary as well as related utilities
to run and administer a MySQL server.

If you want to access and work with the database, you have to install
package "%{mysql_basename}-client" as well!

%package -n %{mysql_basename}-client
Summary: MySQL - Client
Group: Applications/Databases
Obsoletes: mysql-client MySQL-client
Provides: mysql-client MySQL-client

%description -n %{mysql_basename}-client
This package contains the standard MySQL clients and administration tools. 

%{see_base}

%package -n %{mysql_basename}-test
Requires: mysql-client perl
Summary: MySQL - Test suite
Group: Applications/Databases
Provides: mysql-test MySQL-test
Obsoletes: mysql-test MySQL-test
AutoReqProv: no

%description -n %{mysql_basename}-test
This package contains the MySQL regression test suite.

%{see_base}

%package -n %{mysql_basename}-devel
Summary: MySQL - Development header files and libraries
Group: Applications/Databases
Provides: mysql-devel MySQL-devel
Obsoletes: mysql-devel MySQL-devel

%description -n %{mysql_basename}-devel
This package contains the development header files and libraries
necessary to develop MySQL client applications.

%{see_base}

%package -n %{mysql_basename}-shared
Summary: MySQL - Shared libraries
Group: Applications/Databases
Provides: mysql-shared MySQL-shared
# Obsoletes below to correct old missing Provides:/Obsoletes
Obsoletes: mysql-shared MySQL-shared-standard MySQL-shared-pro
Obsoletes: MySQL-shared-pro-cert MySQL-shared-pro-gpl
Obsoletes: MySQL-shared-pro-gpl-cert MySQL-shared

%description -n %{mysql_basename}-shared
This package contains the shared libraries (*.so*) which certain
languages and applications need to dynamically load and use MySQL.

%prep
%setup -n %{upstream_source}

%build

BuildMySQL() {
# Evaluate current setting of $DEBUG
if [ $DEBUG -gt 0 ] ; then
	OPT_COMMENT='--with-comment="(%{comment} - Debug)"'
	OPT_DEBUG='--with-debug'
else
	OPT_COMMENT='--with-comment="(%{comment})"'
	OPT_DEBUG=''
fi

# The --enable-assembler simply does nothing on systems that does not
# support assembler speedups.
sh -c  "CFLAGS=\"${CFLAGS:-$RPM_OPT_FLAGS}\" \
	CXXFLAGS=\"${CXXFLAGS:-$RPM_OPT_FLAGS}\" \
	LDFLAGS=\"$LDFLAGS\" \
	./configure \
 	    $* \
	    --enable-assembler \
	    --enable-local-infile \
		--with-mysqld-user=%{mysqld_user} \
		--with-unix-socket-path=/var/lib/mysql/mysql.sock \
		--with-pic \
		--prefix=/ \
		--with-extra-charsets=complex \
%if %{YASSL_BUILD}
	    --with-yassl \
%endif
		--exec-prefix=%{_exec_prefix} \
        --libexecdir=%{_sbindir} \
        --libdir=%{_libdir} \
        --sysconfdir=%{_sysconfdir} \
        --datadir=%{_datadir} \
        --localstatedir=%{mysqldatadir} \
        --infodir=%{_infodir} \
        --includedir=%{_includedir} \
        --mandir=%{_mandir} \
	    --enable-thread-safe-client \
%if %{?comment:1}0
	    $OPT_COMMENT \
%endif
	    $OPT_DEBUG \
	    --with-readline \
	    ; make -j4"
}
# end of function definition "BuildMySQL"


BuildServer() {
BuildMySQL "--disable-shared \
%if %{?server_suffix:1}0
		--with-server-suffix='%{server_suffix}' \
%endif
		--without-embedded-server \
		--with-innodb \
		--with-csv-storage-engine \
		--with-archive-storage-engine \
		--with-blackhole-storage-engine \
		--with-federated-storage-engine \
		--with-sphinx-storage-engine \
		--with-oqgraph-computation-engine \
		--without-bench \
		--with-zlib-dir=bundled \
		--with-big-tables"

if [ -n "$MYSQL_CONFLOG_DEST" ] ; then
	cp -fp config.log "$MYSQL_CONFLOG_DEST"
fi

if [ -f sql/.libs/mysqld ] ; then
	nm --numeric-sort sql/.libs/mysqld > sql/mysqld.sym
else
	nm --numeric-sort sql/mysqld > sql/mysqld.sym
fi
}
# end of function definition "BuildServer"


RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/%{upstream_source}

# Clean up the BuildRoot first
[ "$RBR" != "/" ] && [ -d $RBR ] && rm -rf $RBR;
mkdir -p $RBR%{_libdir}/mysql $RBR%{_sbindir}

# We need g++ and libstdc++ for GRAPH engine
if [ -z "$CXX" -a -z "$CC" ] ; then
	export CC="gcc" CXX="g++"
fi

case `gcc -dumpmachine` in
          x86_64-*)
		# gcc barfs on -nmarch=... on x64
		CPUOPT="-m64 -mtune=generic"
		;;
          *)
		# i586 to not trip up mobile/lowpower devices
		CPUOPT="-m32 -march=i586 -mtune=generic"
		;;
esac

if [ "%{elversion}" = "5" ] ; then
        export CFLAGS="-O2 -fno-omit-frame-pointer  -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fstack-protector --param=ssp-buffer-size=4 $CPUOPT"
        export CXXFLAGS="-O2 -fno-omit-frame-pointer -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fstack-protector --param=ssp-buffer-size=4 $CPUOPT"
else
        export CC="gcc4" CXX="g++4"
        export CFLAGS="-O2 -fno-omit-frame-pointer  -g -pipe $CPUOPT"
        export CXXFLAGS="-O2 -fno-omit-frame-pointer -g -pipe $CPUOPT"
fi

# 2008-10-03 arjen@openquery.com
# we need the following to set up proper for Sphinx Engine
sh BUILD/autorun.sh

# Create the shared libs seperately to avoid a dependency for the client utilities
DEBUG=0
BuildMySQL "--enable-shared --without-server"

# Install shared libraries
cp -av libmysql/.libs/*.so* $RBR/%{_libdir}
cp -av libmysql_r/.libs/*.so* $RBR/%{_libdir}

# Include libgcc.a in the devel subpackage (BUG 4921)
if expr "$CC" : "gcc.*" > /dev/null && \
   expr "$CC" : ".* gcc.*" > /dev/null ; then
	libgcc=`$CC $CFLAGS --print-libgcc-file`
	if [ -f $libgcc ] ; then
		install -m 644 $libgcc $RBR%{_libdir}/mysql/libmygcc.a
	fi
fi

# Now create a debug server
DEBUG=1
make clean

BuildServer

MYSQL_RPMBUILD_TEST=no

if [ "$MYSQL_RPMBUILD_TEST" != "no" ] ; then
	make test-bt-debug
fi

# Get the debug server and its .sym file from the build tree
if [ -f sql/.libs/mysqld ] ; then
	cp sql/.libs/mysqld $RBR%{_sbindir}/mysqld-debug
else
	cp sql/mysqld       $RBR%{_sbindir}/mysqld-debug
fi

cp sql/mysqld.sym $RBR%{_libdir}/mysql/mysqld-debug.sym

# Now, the default server
DEBUG=0
make clean distclean

BuildServer

MYSQL_RPMBUILD_TEST=yes

if [ "$MYSQL_RPMBUILD_TEST" != "no" ] ; then
	make test-bt
fi


%install
RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/%{upstream_source}

# Ensure that needed directories exists
install -d $RBR%{_sysconfdir}/{logrotate.d,init.d}
install -d $RBR%{mysqldatadir}/mysql
install -d $RBR%{_datadir}/mysql-test
install -d $RBR%{_datadir}/mysql/SELinux/RHEL4
install -d $RBR%{_includedir}
install -d $RBR%{_libdir}
install -d $RBR%{_mandir}
install -d $RBR%{_sbindir}

make DESTDIR=$RBR benchdir_root=%{_datadir} install

# install symbol files ( for stack trace resolution)
install -m644 $MBD/sql/mysqld.sym $RBR%{_libdir}/mysql/mysqld.sym

# Install logrotate and autostart
install -m644 $MBD/support-files/mysql-log-rotate \
        $RBR%{_sysconfdir}/logrotate.d/mysql
install -m755 $MBD/support-files/mysql.server \
        $RBR%{_sysconfdir}/init.d/mysql

# Create a symlink "rcmysql", pointing to the init.script. SuSE users
# will appreciate that, as all services usually offer this.
ln -s %{_sysconfdir}/init.d/mysql $RBR%{_sbindir}/rcmysql

# Create symbolic compatibility link safe_mysqld -> mysqld_safe
# (safe_mysqld will be gone in MySQL 4.1)
ln -sf ./mysqld_safe $RBR%{_bindir}/safe_mysqld

# Touch the place where the my.cnf config file might be located
# Just to make sure it's in the file list and marked as a config file
touch $RBR%{_sysconfdir}/my.cnf
touch $RBR%{_sysconfdir}/mysqlmanager.passwd

# Install SELinux files in datadir
install -m600 $MBD/support-files/RHEL4-SElinux/mysql.{fc,te} \
	$RBR%{_datadir}/mysql/SELinux/RHEL4


%pre -n %{mysql_basename}-server
# Check if we can safely upgrade.  An upgrade is only safe if it's from one
# of our RPMs in the same version family.

installed=`rpm -q --whatprovides mysql-server 2> /dev/null`
if [ $? -eq 0 -a -n "$installed" ]; then
  vendor=`rpm -q --queryformat='%{VENDOR}' "$installed" 2>&1`
  version=`rpm -q --queryformat='%{VERSION}' "$installed" 2>&1`
  myvendor='%{mysql_packager}'
  myversion='%{mysqlversion}'

  old_family=`echo $version   | sed -n -e 's,^\([1-9][0-9]*\.[0-9][0-9]*\)\..*$,\1,p'`
  new_family=`echo $myversion | sed -n -e 's,^\([1-9][0-9]*\.[0-9][0-9]*\)\..*$,\1,p'`

  [ -z "$vendor" ] && vendor='<unknown>'
  [ -z "$old_family" ] && old_family="<unrecognized version $version>"
  [ -z "$new_family" ] && new_family="<bad package specification: version $myversion>"

  error_text=
  if [ "$vendor" != "$myvendor" ]; then
    error_text="$error_text
The current MySQL server package is provided by a different
vendor ($vendor) than $myvendor.  Some files may be installed
to different locations, including log files and the service
startup script in %{_sysconfdir}/init.d/.
"
  fi

  if [ "$old_family" != "$new_family" ]; then
    error_text="$error_text
Upgrading directly from MySQL $old_family to MySQL $new_family may not
be safe in all cases.  A manual dump and restore using mysqldump is
recommended.  It is important to review the MySQL manual's Upgrading
section for version-specific incompatibilities.
"
  fi

  if [ -n "$error_text" ]; then
    cat <<HERE >&2

******************************************************************
A MySQL server package ($installed) is installed.
$error_text
A manual upgrade is required.

- Ensure that you have a complete, working backup of your data and my.cnf
  files
- Shut down the MySQL server cleanly
- Remove the existing MySQL packages.  Usually this command will
  list the packages you should remove:
  rpm -qa | grep -i '^mysql-'

  You may choose to use 'rpm --nodeps -ev <package-name>' to remove
  the package which contains the mysqlclient shared library.  The
  library will be reinstalled by the MySQL-shared-compat package.
- Install the new MySQL packages supplied by $myvendor
- Ensure that the MySQL server is started
- Run the 'mysql_upgrade' program

This is a brief description of the upgrade process.  Important details
can be found in the MySQL manual, in the Upgrading section.
******************************************************************
HERE
    exit 1
  fi
fi

# Shut down a previously installed server first
if [ -x %{_sysconfdir}/init.d/mysql ] ; then
	%{_sysconfdir}/init.d/mysql stop > /dev/null 2>&1
	echo "Giving mysqld 5 seconds to exit nicely"
	sleep 5
fi

%post -n %{mysql_basename}-server
mysql_datadir=%{mysqldatadir}

# Create data directory
mkdir -p $mysql_datadir/{mysql,test}

# Make MySQL start/shutdown automatically when the machine does it.
if [ -x /sbin/chkconfig ] ; then
	/sbin/chkconfig --add mysql
fi



# Create a MySQL user and group. Do not report any problems if it already
# exists.
groupadd -r %{mysqld_group} 2> /dev/null || true
useradd -M -r -d $mysql_datadir -s /bin/bash -c "MySQL server" -g %{mysqld_group} %{mysqld_user} 2> /dev/null || true 
# The user may already exist, make sure it has the proper group nevertheless (BUG#12823)
usermod -g %{mysqld_group} %{mysqld_user} 2> /dev/null || true

# Change permissions so that the user that will run the MySQL daemon
# owns all database files.
chown -R %{mysqld_user}:%{mysqld_group} $mysql_datadir

# Initiate databases
%{_bindir}/mysql_install_db --rpm --user=%{mysqld_user}

# Upgrade databases if needed would go here - but it cannot be automated yet

# Change permissions again to fix any new files.
chown -R %{mysqld_user}:%{mysqld_group} $mysql_datadir

# Fix permissions for the permission database so that only the user
# can read them.
chmod -R og-rw $mysql_datadir/mysql

# install SELinux files - but don't override existing ones
SETARGETDIR=/etc/selinux/targeted/src/policy
SEDOMPROG=$SETARGETDIR/domains/program
SECONPROG=$SETARGETDIR/file_contexts/program
if [ -f /etc/redhat-release ] \
   && grep -q "Red Hat Enterprise Linux .. release 4" /etc/redhat-release \
   || grep -q "CentOS release 4" /etc/redhat-release ; then
   echo
   echo
   echo 'Notes regarding SELinux on this platform:'
   echo '========================================='
   echo
   echo 'The default policy might cause server startup to fail because it is '
   echo 'not allowed to access critical files. In this case, please update '
   echo 'your installation. '
   echo
   echo 'The default policy might also cause inavailability of SSL related '
   echo 'features because the server is not allowed to access /dev/random '
   echo 'and /dev/urandom. If this is a problem, please do the following: '
   echo 
   echo '  1) install selinux-policy-targeted-sources from your OS vendor'
   echo '  2) add the following two lines to '$SEDOMPROG/mysqld.te':'
   echo '       allow mysqld_t random_device_t:chr_file read;'
   echo '       allow mysqld_t urandom_device_t:chr_file read;'
   echo '  3) cd to '$SETARGETDIR' and issue the following command:'
   echo '       make load'
   echo
   echo
fi

if [ -x sbin/restorecon ] ; then
	sbin/restorecon -R var/lib/mysql
fi

# Restart in the same way that mysqld will be started normally.
if [ -x %{_sysconfdir}/init.d/mysql ] ; then
	%{_sysconfdir}/init.d/mysql start
	echo "Giving mysqld 2 seconds to start"
	sleep 2
fi

# Allow safe_mysqld to start mysqld and print a message before we exit
sleep 2


%preun -n %{mysql_basename}-server
if [ $1 = 0 ] ; then
	# Stop MySQL before uninstalling it
	if [ -x %{_sysconfdir}/init.d/mysql ] ; then
		%{_sysconfdir}/init.d/mysql stop > /dev/null
		# Don't start it automatically anymore
		if [ -x /sbin/chkconfig ] ; then
			/sbin/chkconfig --del mysql
		fi
	fi
fi

# We do not remove the mysql user since it may still own a lot of
# database files.

# Clean up the BuildRoot
%clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files -n %{mysql_basename}-server
%defattr(-,root,root,0755)

%doc COPYING README
%doc support-files/my-*.cnf

%doc %attr(644, root, root) %{_infodir}/mysql.info*

%doc %attr(644, root, man) %{_mandir}/man1/innochecksum.1*
%doc %attr(644, root, man) %{_mandir}/man1/my_print_defaults.1*
%doc %attr(644, root, man) %{_mandir}/man1/myisam_ftdump.1*
%doc %attr(644, root, man) %{_mandir}/man1/myisamchk.1*
%doc %attr(644, root, man) %{_mandir}/man1/myisamlog.1*
%doc %attr(644, root, man) %{_mandir}/man1/myisampack.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_convert_table_format.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_explain_log.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_fix_extensions.1*
%doc %attr(644, root, man) %{_mandir}/man8/mysqld.8*
%doc %attr(644, root, man) %{_mandir}/man1/mysqld_multi.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqld_safe.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_fix_privilege_tables.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_install_db.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_secure_installation.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_setpermission.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_upgrade.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlhotcopy.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlman.1*
%doc %attr(644, root, man) %{_mandir}/man8/mysqlmanager.8*
%doc %attr(644, root, man) %{_mandir}/man1/mysql.server.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqltest.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_tzinfo_to_sql.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_zap.1*
%doc %attr(644, root, man) %{_mandir}/man1/perror.1*
%doc %attr(644, root, man) %{_mandir}/man1/replace.1*
%doc %attr(644, root, man) %{_mandir}/man1/resolve_stack_dump.1*
%doc %attr(644, root, man) %{_mandir}/man1/resolveip.1*
%doc %attr(644, root, man) %{_mandir}/man1/safe_mysqld.1*

%ghost %config(noreplace,missingok) %{_sysconfdir}/my.cnf
%ghost %config(noreplace,missingok) %{_sysconfdir}/mysqlmanager.passwd

%attr(755, root, root) %{_bindir}/innochecksum
%attr(755, root, root) %{_bindir}/my_print_defaults
%attr(755, root, root) %{_bindir}/myisam_ftdump
%attr(755, root, root) %{_bindir}/myisamchk
%attr(755, root, root) %{_bindir}/myisamlog
%attr(755, root, root) %{_bindir}/myisampack
%attr(755, root, root) %{_bindir}/mysql_convert_table_format
%attr(755, root, root) %{_bindir}/mysql_explain_log
%attr(755, root, root) %{_bindir}/mysql_fix_extensions
%attr(755, root, root) %{_bindir}/mysql_fix_privilege_tables
%attr(755, root, root) %{_bindir}/mysql_install_db
%attr(755, root, root) %{_bindir}/mysql_secure_installation
%attr(755, root, root) %{_bindir}/mysql_setpermission
%attr(755, root, root) %{_bindir}/mysql_tzinfo_to_sql
%attr(755, root, root) %{_bindir}/mysql_upgrade
%attr(755, root, root) %{_bindir}/mysql_zap
%attr(755, root, root) %{_bindir}/mysqlbug
%attr(755, root, root) %{_bindir}/mysqld_multi
%attr(755, root, root) %{_bindir}/mysqld_safe
%attr(755, root, root) %{_bindir}/mysqldumpslow
%attr(755, root, root) %{_bindir}/mysqlhotcopy
%attr(755, root, root) %{_bindir}/mysqltest
%attr(755, root, root) %{_bindir}/perror
%attr(755, root, root) %{_bindir}/replace
%attr(755, root, root) %{_bindir}/resolve_stack_dump
%attr(755, root, root) %{_bindir}/resolveip
%attr(755, root, root) %{_bindir}/safe_mysqld

%attr(755, root, root) %{_sbindir}/mysqld
%attr(755, root, root) %{_sbindir}/mysqld-debug
%attr(755, root, root) %{_sbindir}/mysqlmanager
%attr(755, root, root) %{_sbindir}/rcmysql
%attr(644, root, root) %{_libdir}/mysql/mysqld.sym
%attr(644, root, root) %{_libdir}/mysql/mysqld-debug.sym

%attr(644, root, root) %config(noreplace,missingok) %{_sysconfdir}/logrotate.d/mysql
%attr(755, root, root) %{_sysconfdir}/init.d/mysql

%attr(755, root, root) %{_datadir}/mysql/

%files -n %{mysql_basename}-client
%defattr(-, root, root, 0755)
%attr(755, root, root) %{_bindir}/msql2mysql
%attr(755, root, root) %{_bindir}/mysql
%attr(755, root, root) %{_bindir}/mysql_find_rows
%attr(755, root, root) %{_bindir}/mysql_tableinfo
%attr(755, root, root) %{_bindir}/mysql_upgrade_shell
%attr(755, root, root) %{_bindir}/mysql_waitpid
%attr(755, root, root) %{_bindir}/mysqlaccess
%attr(755, root, root) %{_bindir}/mysqladmin
%attr(755, root, root) %{_bindir}/mysqlbinlog
%attr(755, root, root) %{_bindir}/mysqlcheck
%attr(755, root, root) %{_bindir}/mysqldump
%attr(755, root, root) %{_bindir}/mysqlimport
%attr(755, root, root) %{_bindir}/mysqlshow

%doc %attr(644, root, man) %{_mandir}/man1/msql2mysql.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_tableinfo.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_waitpid.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlaccess.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqladmin.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlbinlog.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlcheck.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqldump.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlimport.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlshow.1*

%post -n %{mysql_basename}-shared
/sbin/ldconfig

%postun -n %{mysql_basename}-shared
/sbin/ldconfig

%files -n %{mysql_basename}-devel
%defattr(-, root, root, 0755)
%doc EXCEPTIONS-CLIENT
%doc %attr(644, root, man) %{_mandir}/man1/comp_err.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_config.1*
%attr(755, root, root) %{_bindir}/comp_err
%attr(755, root, root) %{_bindir}/mysql_config
%dir %attr(755, root, root) %{_libdir}/mysql
%{_includedir}/mysql
%{_libdir}/mysql/libdbug.a
%{_libdir}/mysql/libheap.a
%{_libdir}/mysql/libmy*.a
%{_libdir}/mysql/libmy*.la
%{_libdir}/mysql/libvio.a
%{_libdir}/mysql/libz*

%files -n %{mysql_basename}-shared
%defattr(-, root, root, 0755)
# Shared libraries (omit for architectures that don't support them)
%{_libdir}/*.so*


%files -n %{mysql_basename}-test
%defattr(-, root, root, 0755)
%{_datadir}/mysql-test
%attr(755, root, root) %{_bindir}/mysql_client_test
%attr(755, root, root) %{_bindir}/mysqltestmanager
%attr(755, root, root) %{_bindir}/mysqltestmanager-pwgen
%attr(755, root, root) %{_bindir}/mysqltestmanagerc
%doc %attr(644, root, man) %{_mandir}/man1/mysql_client_test.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql-stress-test.pl.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql-test-run.pl.1*

# The spec file changelog only includes changes made to the spec file
# itself - note that they must be ordered by date (important when
# merging BK trees)
%changelog
* Mon Oct 05 2008 Arjen Lentz <arjen@openquery.com>

- Pruned SPEC to start sorting out the mess
- Pruned changelog
