# OurDelta RPM SPEC for MySQL 5.1 builds on CentOS 4/5
# 2008-10-05 arjen@openquery.com Initial foo
# 2008-11-04 arjen@openquery.com Updated patch/build process
# 2009-03-24 arjen@openquery.com Fixups for 5.0.77, and now 4/7 not 4_6/5_2
# 2009-05-18 toby@openquery.com For 5.1 (#263)
# 2009-09-28 arjen@openquery.com Fixups for 5.1.38 (MariaDB)
# 2009-10-12 arjen@openquery.com more 5.1 fixups/cleanups
# 2009-11-08 arjen@openquery.com 5.0 (.so.15) compatibility rpm pull-in
# 2009-11-08 arjen@openquery.com remove mysqld-debug, we have a .sym
#
# rpmbuild -ba mysql-ourdelta-centos.spec --sign --define 'ourdelta 1'
# rpmbuild -ba mysql-ourdelta-centos.spec --sign --define 'ourdeltasail 1'
#       --define 'mysqlversion 5.1.38'
#       --define 'elversion 4'        or      --define 'elversion 5'
#	--define 'patchset d5'
#	--define 'buildrev 0'
#	--define 'compat50rpm <filename>'
#
%define mysql_packager	OurDelta - http://ourdelta.org/

#no extra 5.1 patches right now so we leave off the .dN
#%define extversion      %{mysqlversion}.%{patchset}
%define extversion	%{mysqlversion}
%define distribution	el%{elversion}
%define release		%{buildrev}.%{distribution}

# Meta information


# Product definitions - one of these has to be defined via the RPM build
# options, e.g. "--define 'ourdelta 1'"
#
%{!?ourdelta:%define ourdelta 0}
%{!?ourdeltasail:%define ourdeltasail 0}

# On SuSE 9 no separate "debuginfo" package is built. To enable basic
# debugging on that platform, we don't strip binaries on SuSE 9. We
# disable the strip of binaries by redefining the RPM macro
# "__os_install_post" leaving out the script calls that normally does
# this. We do this in all cases, as on platforms where "debuginfo" is
# created, a script "find-debuginfo.sh" will be called that will do
# the strip anyway, part of separating the executable and debug
# information into separate files put into separate packages.
#
# Some references (shows more advanced conditional usage):
# http://www.redhat.com/archives/rpm-list/2001-November/msg00257.html
# http://www.redhat.com/archives/rpm-list/2003-February/msg00275.html
# http://www.redhat.com/archives/rhl-devel-list/2004-January/msg01546.html
# http://lists.opensuse.org/archive/opensuse-commit/2006-May/1171.html

%define __os_install_post /usr/lib/rpm/brp-compress

# (comment) parentheses get added later as we might suffix "- Debug" also
%define comment MariaDB - http://mariadb.com/


%if %{ourdelta}
%define mysql_basename	MariaDB
#no extra 5.1 patches right now so we leave off the .dN
#%define server_suffix  .%{patchset}-ourdelta%{buildrev}
%define server_suffix	-mariadb%{buildrev}
%endif

%if %{ourdeltasail}
%define mysql_basename	MariaDB-OurDelta-Sail
#no extra 5.1 patches right now so we leave off the .dN
#%define server_suffix	.%{patchset}-ourdelta-sail%{buildrev}
%define server_suffix   -ourdelta-sail%{buildrev}
%endif


%define mysqld_user	mysql
%define mysqld_group	mysql
%define mysqldatadir	/var/lib/mysql

# We don't package all files installed into the build root by intention -
# See BUG#998 for details.
%define _unpackaged_files_terminate_build 0

%define see_base For a description of MySQL see the base MariaDB RPM
Source0:	%{upstream_source}.tar.gz
Source1:	%{compat50rpm}
Name:		%{mysql_basename}
Summary:	MariaDB: a very fast and robust SQL database server
Group:		Applications/Databases
Version:	%{extversion}
Release:	%{release}
Distribution:	%{distribution}
License:	GPL
Source:		%{upstream_source}.tar.gz
URL:		http://mariadb.com/
Packager:	%{mysql_packager}
Vendor:		MariaDB (http://mariadb.com/)
Provides:	msqlormysql MySQL-server MariaDB-server mysql MariaDB
BuildRequires:  gperf perl readline-devel gcc-c++ ncurses-devel zlib-devel libtool automake autoconf time

# Think about what you use here since the first step is to
# run a rm -rf
BuildRoot:    %{_tmppath}/%{name}-%{extversion}-build

%description
The MariaDB software is a very fast and robust SQL database server.

It is GPL v2 licensed, which means you can use the it free of charge under the
conditions of the GNU General Public License Version 2 (http://www.gnu.org/licenses/).

MariaDB documentation can be found at http://askmonty.org/wiki/index.php/Manual:Contents
MariaDB bug reports should be submitted through https://bugs.launchpad.net/maria

Issues related to the OurDelta packaging should be submitted in the OurDelta
project on Launchpad, simply follow the links via http://ourdelta.org/
There you will also find references to companies that provide MariaDB-related
services such as training, architecture assistance, and performance tuning.

%package -n %{mysql_basename}-server
Summary:	%{mysql_basename} for %{distribution}
Group:		Applications/Databases
Requires: chkconfig coreutils shadow-utils grep procps
Provides:	msqlormysql mysql-server MariaDB mysql MySQL-server MariaDB-server
Obsoletes:	MariaDB mysql mysql-server MySQL-server MariaDB-server MySQL-OurDelta-server

%description -n %{mysql_basename}-server
The MariaDB software is a very fast and robust SQL database server.

It is GPL v2 licensed, which means you can use the it free of charge under the
conditions of the GNU General Public License Version 2 (http://www.gnu.org/licenses/).

MariaDB documentation can be found at http://askmonty.org/wiki/index.php/Manual:Contents
MariaDB bug reports should be submitted through https://bugs.launchpad.net/maria

Issues related to the OurDelta packaging should be submitted in the OurDelta
project on Launchpad, simply follow the links via http://ourdelta.org/
There you will also find references to companies that provide MariaDB-related
services such as training, architecture assistance, and performance tuning.

This package includes the MariaDB server binary as well as related utilities
to run and administer a MariaDB server.

If you want to access and work with the database, you have to install
package "%{mysql_basename}-client" as well!

%package -n %{mysql_basename}-client
Summary: MariaDB - Client
Group: Applications/Databases
Obsoletes: mysql-client MariaDB-client MySQL-client MySQL-OurDelta-client
Provides: mysql-client MariaDB-client MySQL-client

%description -n %{mysql_basename}-client
This package contains the standard MySQL clients and administration tools. 

%{see_base}

%package -n %{mysql_basename}-test
Requires: MariaDB-client perl
Summary: MariaDB - Test suite
Group: Applications/Databases
Provides: mysql-test MariaDB-test MySQL-test
Obsoletes: mysql-test MariaDB-test MySQL-test MySQL-OurDelta-test
AutoReqProv: no

%description -n %{mysql_basename}-test
This package contains the MariaDB regression test suite.

%{see_base}

%package -n %{mysql_basename}-devel
Summary: MariaDB - Development header files and libraries
Group: Applications/Databases
Provides: mysql-devel MariaDB-devel MySQL-devel
Obsoletes: mysql-devel MariaDB-devel MySQL-devel MySQL-OurDelta-devel

%description -n %{mysql_basename}-devel
This package contains the development header files and libraries
necessary to develop MariaDB client applications.

%{see_base}

%package -n %{mysql_basename}-shared
Summary: MariaDB - Shared libraries
Group: Applications/Databases
Provides: MariaDB-shared mysql-shared MySQL-shared
# Obsoletes below to correct old missing Provides:/Obsoletes
Obsoletes: mysql-shared MySQL-shared-standard MySQL-shared-pro
Obsoletes: MySQL-shared-pro-cert MySQL-shared-pro-gpl
Obsoletes: MySQL-shared-pro-gpl-cert MariaDB-shared MySQL-shared MySQL-OurDelta-shared

%description -n %{mysql_basename}-shared
This package contains the shared libraries (*.so*) which certain
languages and applications need to dynamically load and use MariaDB.

%prep
%setup -n %{upstream_source}

%build

BuildMySQL() {
# Evaluate current setting of $DEBUG
if [ $DEBUG -gt 0 ] ; then
	OPT_COMMENT='--with-comment="(%{comment} - Debug)"'
	OPT_DEBUG='--with-debug'
else
	OPT_COMMENT='--with-comment="(%{comment})"'
	OPT_DEBUG=''
fi

# The --enable-assembler simply does nothing on systems that does not
# support assembler speedups.
sh -c  "CFLAGS=\"${CFLAGS:-$RPM_OPT_FLAGS}\" \
	CXXFLAGS=\"${CXXFLAGS:-$RPM_OPT_FLAGS}\" \
	LDFLAGS=\"$LDFLAGS\" \
	./configure \
		$* \
		--enable-local-infile \
		--with-mysqld-user=%{mysqld_user} \
		--with-unix-socket-path=/var/lib/mysql/mysql.sock \
		--with-pic \
		--prefix=/ \
		--without-docs --with-extra-charsets=all \
		--with-ssl \
		--exec-prefix=%{_exec_prefix} \
		--libexecdir=%{_sbindir} \
		--libdir=%{_libdir} \
		--sysconfdir=%{_sysconfdir} \
		--datadir=%{_datadir} \
		--localstatedir=%{mysqldatadir} \
		--infodir=%{_infodir} \
		--includedir=%{_includedir} \
		--mandir=%{_mandir} \
	        --enable-thread-safe-client \
	        --enable-shared --enable-static \
%if %{?comment:1}0
		$OPT_COMMENT \
%endif
		$OPT_DEBUG \
		--with-readline \
	    ; make -j4"
}
# end of function definition "BuildMySQL"


BuildServer() {
BuildMySQL "--disable-shared \
%if %{?server_suffix:1}0
		--with-server-suffix='%{server_suffix}' \
%endif
		--without-bench \
                --enable-local-infile --with-big-tables \
	        --with-libwrap --with-readline --with-libevent --with-zlib-dir=bundled \
	        --with-partition --with-embedded-server \
	        --with-plugins=max-no-ndb \
	        --without-plugin-innodb_plugin"

if [ -n "$MYSQL_CONFLOG_DEST" ] ; then
	cp -fp config.log "$MYSQL_CONFLOG_DEST"
fi

if [ -f sql/.libs/mysqld ] ; then
	nm --numeric-sort sql/.libs/mysqld > sql/mysqld.sym
else
	nm --numeric-sort sql/mysqld > sql/mysqld.sym
fi
}
# end of function definition "BuildServer"


RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/%{upstream_source}

# Clean up the BuildRoot first
[ "$RBR" != "/" ] && [ -d $RBR ] && rm -rf $RBR;
mkdir -p $RBR%{_libdir}/mysql $RBR%{_sbindir}

# Use gcc for C and C++ code (to avoid a dependency on libstdc++ and
# including exceptions into the code
if [ -z "$CXX" -a -z "$CC" ] ; then
	export CC="gcc" CXX="g++"
fi

case `gcc -dumpmachine` in
          x86_64-*)
		# gcc barfs on -nmarch=... on x64
		CPUOPT="-m64 -mtune=generic"
		;;
          *)
		# i586 to not trip up mobile/lowpower devices
		CPUOPT="-m32 -march=i586 -mtune=generic"
		;;
esac

if [ "%{elversion}" = "5" ] ; then
        export CFLAGS="-O2 -fno-omit-frame-pointer  -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fstack-protector --param=ssp-buffer-size=4 $CPUOPT"
        export CXXFLAGS="-O2 -fno-omit-frame-pointer -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fstack-protector --param=ssp-buffer-size=4 $CPUOPT"
else
        export CC="gcc4" CXX="gcc4"
        export CFLAGS="-O2 -fno-omit-frame-pointer  -g -pipe $CPUOPT"
        export CXXFLAGS="-O2 -fno-omit-frame-pointer -g -pipe $CPUOPT"
fi

# 2008-10-03 arjen@openquery.com
# we need the following to set up proper for Sphinx Engine
sh BUILD/autorun.sh

# Create the shared libs seperately to avoid a dependency for the client utilities
DEBUG=0
BuildMySQL "--enable-shared --without-server"

# Install shared libraries
cp -av libmysql/.libs/*.so* $RBR/%{_libdir}
cp -av libmysql_r/.libs/*.so* $RBR/%{_libdir}

# Include libgcc.a in the devel subpackage (BUG 4921)
if expr "$CC" : "gcc.*" > /dev/null && \
   expr "$CC" : ".* gcc.*" > /dev/null ; then
	libgcc=`$CC $CFLAGS --print-libgcc-file`
	if [ -f $libgcc ] ; then
		install -m 644 $libgcc $RBR%{_libdir}/mysql/libmygcc.a
	fi
fi

# Now, the default server
DEBUG=0
make clean distclean

BuildServer

MYSQL_RPMBUILD_TEST=no

if [ "$MYSQL_RPMBUILD_TEST" != "no" ] ; then
	make test-bt
fi


%install
RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/%{upstream_source}

# Ensure that needed directories exists
install -d $RBR%{_sysconfdir}/{logrotate.d,init.d}
install -d $RBR%{mysqldatadir}/mysql
install -d $RBR%{_datadir}/mysql-test
install -d $RBR%{_datadir}/mysql/SELinux/RHEL4
install -d $RBR%{_includedir}
install -d $RBR%{_libdir}
install -d $RBR%{_mandir}
install -d $RBR%{_infodir}
install -d $RBR%{_sbindir}

make DESTDIR=$RBR benchdir_root=%{_datadir} install

# install symbol files ( for stack trace resolution)
install -m644 $MBD/sql/mysqld.sym $RBR%{_libdir}/mysql/mysqld.sym

# Install logrotate and autostart
install -m644 $MBD/support-files/mysql-log-rotate \
        $RBR%{_sysconfdir}/logrotate.d/mysql
install -m755 $MBD/support-files/mysql.server \
        $RBR%{_sysconfdir}/init.d/mysql

# Create a symlink "rcmysql", pointing to the init.script. SuSE users
# will appreciate that, as all services usually offer this.
ln -s %{_sysconfdir}/init.d/mysql $RBR%{_sbindir}/rcmysql

# Create symbolic compatibility link safe_mysqld -> mysqld_safe
# (safe_mysqld will be gone in MySQL 4.1)
ln -sf ./mysqld_safe $RBR%{_bindir}/safe_mysqld

# Touch the place where the my.cnf config file might be located
# Just to make sure it's in the file list and marked as a config file
touch $RBR%{_sysconfdir}/my.cnf
touch $RBR%{_sysconfdir}/mysqlmanager.passwd

# Install SELinux files in datadir
install -m600 $MBD/support-files/RHEL4-SElinux/mysql.{fc,te} \
	$RBR%{_datadir}/mysql/SELinux/RHEL4

# extract .so.15 compatibility libraries from 5.0 rpm
# they end up in /usr/lib or /usr/lib64, regular packaging does the rest
cd $RBR
rpm2cpio %{SOURCE1} | cpio -iv --make-directories

%pre -n %{mysql_basename}-server
# Check if we can safely upgrade.  An upgrade is only safe if it's from one
# of our RPMs in the same version family.

installed=`rpm -q --whatprovides mysql-server 2> /dev/null`
if [ $? -eq 0 -a -n "$installed" ]; then
  vendor=`rpm -q --queryformat='%{VENDOR}' "$installed" 2>&1`
  version=`rpm -q --queryformat='%{VERSION}' "$installed" 2>&1`
  myvendor='%{mysql_packager}'
  myversion='%{mysqlversion}'

  old_family=`echo $version   | sed -n -e 's,^\([1-9][0-9]*\.[0-9][0-9]*\)\..*$,\1,p'`
  new_family=`echo $myversion | sed -n -e 's,^\([1-9][0-9]*\.[0-9][0-9]*\)\..*$,\1,p'`

  [ -z "$vendor" ] && vendor='<unknown>'
  [ -z "$old_family" ] && old_family="<unrecognized version $version>"
  [ -z "$new_family" ] && new_family="<bad package specification: version $myversion>"

  error_text=
  if [ "$vendor" != "$myvendor" ]; then
    error_text="$error_text
The current MariaDB server package is provided by a different
vendor ($vendor) than $myvendor.  Some files may be installed
to different locations, including log files and the service
startup script in %{_sysconfdir}/init.d/.
"
  fi

  if [ "$old_family" != "$new_family" ]; then
    error_text="$error_text
Upgrading directly from MySQL $old_family to MariaDB $new_family may not
be safe in all cases.  A manual dump and restore using mysqldump is
recommended.  It is important to review the MariaDB manual's Upgrading
section for version-specific incompatibilities.
"
  fi

  if [ -n "$error_text" ]; then
    cat <<HERE >&2

******************************************************************
A MySQL or MariaDB server package ($installed) is installed.
$error_text
A manual upgrade is required.

- Ensure that you have a complete, working backup of your data and my.cnf
  files
- Shut down the MySQL server cleanly
- Remove the existing MySQL packages.  Usually this command will
  list the packages you should remove:
  rpm -qa | grep -i '^mysql-'

  You may choose to use 'rpm --nodeps -ev <package-name>' to remove
  the package which contains the mysqlclient shared library.  The
  library will be reinstalled by the MariaDB-shared package.
- Install the new MariaDB packages supplied by $myvendor
- Ensure that the MariaDB server is started
- Run the 'mysql_upgrade' program

This is a brief description of the upgrade process.  Important details
can be found in the MariaDB manual, in the Upgrading section.
******************************************************************
HERE
    exit 1
  fi
fi

# Shut down a previously installed server first
if [ -x %{_sysconfdir}/init.d/mysql ] ; then
	%{_sysconfdir}/init.d/mysql stop > /dev/null 2>&1
	echo "Giving mysqld 5 seconds to exit nicely"
	sleep 5
fi

%post -n %{mysql_basename}-server
mysql_datadir=%{mysqldatadir}

# Create data directory
mkdir -p $mysql_datadir/{mysql,test}

# Make MySQL start/shutdown automatically when the machine does it.
if [ -x /sbin/chkconfig ] ; then
	/sbin/chkconfig --add mysql
fi



# Create a MySQL user and group. Do not report any problems if it already
# exists.
groupadd -r %{mysqld_group} 2> /dev/null || true
useradd -M -r -d $mysql_datadir -s /bin/bash -c "MySQL server" -g %{mysqld_group} %{mysqld_user} 2> /dev/null || true 
# The user may already exist, make sure it has the proper group nevertheless (BUG#12823)
usermod -g %{mysqld_group} %{mysqld_user} 2> /dev/null || true

# Change permissions so that the user that will run the MySQL daemon
# owns all database files.
chown -R %{mysqld_user}:%{mysqld_group} $mysql_datadir

# Initiate databases
%{_bindir}/mysql_install_db --rpm --user=%{mysqld_user}

# Upgrade databases if needed would go here - but it cannot be automated yet

# Change permissions again to fix any new files.
chown -R %{mysqld_user}:%{mysqld_group} $mysql_datadir

# Fix permissions for the permission database so that only the user
# can read them.
chmod -R og-rw $mysql_datadir/mysql

# install SELinux files - but don't override existing ones
SETARGETDIR=/etc/selinux/targeted/src/policy
SEDOMPROG=$SETARGETDIR/domains/program
SECONPROG=$SETARGETDIR/file_contexts/program
if [ -f /etc/redhat-release ] \
   && grep -q "Red Hat Enterprise Linux .. release 4" /etc/redhat-release \
   || grep -q "CentOS release 4" /etc/redhat-release ; then
   echo
   echo
   echo 'Notes regarding SELinux on this platform:'
   echo '========================================='
   echo
   echo 'The default policy might cause server startup to fail because it is '
   echo 'not allowed to access critical files. In this case, please update '
   echo 'your installation. '
   echo
   echo 'The default policy might also cause inavailability of SSL related '
   echo 'features because the server is not allowed to access /dev/random '
   echo 'and /dev/urandom. If this is a problem, please do the following: '
   echo 
   echo '  1) install selinux-policy-targeted-sources from your OS vendor'
   echo '  2) add the following two lines to '$SEDOMPROG/mysqld.te':'
   echo '       allow mysqld_t random_device_t:chr_file read;'
   echo '       allow mysqld_t urandom_device_t:chr_file read;'
   echo '  3) cd to '$SETARGETDIR' and issue the following command:'
   echo '       make load'
   echo
   echo
fi

if [ -x sbin/restorecon ] ; then
	sbin/restorecon -R var/lib/mysql
fi

# Restart in the same way that mysqld will be started normally.
if [ -x %{_sysconfdir}/init.d/mysql ] ; then
	%{_sysconfdir}/init.d/mysql start
	echo "Giving mysqld 2 seconds to start"
	sleep 2
fi

# Allow safe_mysqld to start mysqld and print a message before we exit
sleep 2


%preun -n %{mysql_basename}-server
if [ $1 = 0 ] ; then
	# Stop MySQL before uninstalling it
	if [ -x %{_sysconfdir}/init.d/mysql ] ; then
		%{_sysconfdir}/init.d/mysql stop > /dev/null
		# Don't start it automatically anymore
		if [ -x /sbin/chkconfig ] ; then
			/sbin/chkconfig --del mysql
		fi
	fi
fi

# We do not remove the mysql user since it may still own a lot of
# database files.

# Clean up the BuildRoot
%clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files -n %{mysql_basename}-server
%defattr(-,root,root,0755)

%doc COPYING README
#obsolete crap
#%doc support-files/my-*.cnf

#%doc %attr(644, root, root) %{_infodir}/mysql.info*

%doc %attr(644, root, man) %{_mandir}/man1/innochecksum.1*
%doc %attr(644, root, man) %{_mandir}/man1/my_print_defaults.1*
%doc %attr(644, root, man) %{_mandir}/man1/myisam_ftdump.1*
%doc %attr(644, root, man) %{_mandir}/man1/myisamchk.1*
%doc %attr(644, root, man) %{_mandir}/man1/myisamlog.1*
%doc %attr(644, root, man) %{_mandir}/man1/myisampack.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_convert_table_format.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_fix_extensions.1*
%doc %attr(644, root, man) %{_mandir}/man8/mysqld.8*
%doc %attr(644, root, man) %{_mandir}/man1/mysqld_multi.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqld_safe.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqldumpslow.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_fix_privilege_tables.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_install_db.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_secure_installation.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_setpermission.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_upgrade.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlhotcopy.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlman.1*
%doc %attr(644, root, man) %{_mandir}/man8/mysqlmanager.8*
%doc %attr(644, root, man) %{_mandir}/man1/mysql.server.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqltest.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_tzinfo_to_sql.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_zap.1*
%doc %attr(644, root, man) %{_mandir}/man1/perror.1*
%doc %attr(644, root, man) %{_mandir}/man1/replace.1*
%doc %attr(644, root, man) %{_mandir}/man1/resolve_stack_dump.1*
%doc %attr(644, root, man) %{_mandir}/man1/resolveip.1*

%ghost %config(noreplace,missingok) %{_sysconfdir}/my.cnf
%ghost %config(noreplace,missingok) %{_sysconfdir}/mysqlmanager.passwd

%attr(755, root, root) %{_bindir}/innochecksum
%attr(755, root, root) %{_bindir}/my_print_defaults
%attr(755, root, root) %{_bindir}/myisam_ftdump
%attr(755, root, root) %{_bindir}/myisamchk
%attr(755, root, root) %{_bindir}/myisamlog
%attr(755, root, root) %{_bindir}/myisampack
%attr(755, root, root) %{_bindir}/maria_pack
%attr(755, root, root) %{_bindir}/maria_read_log
%attr(755, root, root) %{_bindir}/maria_ftdump
%attr(755, root, root) %{_bindir}/maria_chk
%attr(755, root, root) %{_bindir}/maria_dump_log
%attr(755, root, root) %{_bindir}/mysql_convert_table_format
%attr(755, root, root) %{_bindir}/mysql_fix_extensions
%attr(755, root, root) %{_bindir}/mysql_fix_privilege_tables
%attr(755, root, root) %{_bindir}/mysql_install_db
%attr(755, root, root) %{_bindir}/mysql_secure_installation
%attr(755, root, root) %{_bindir}/mysql_setpermission
%attr(755, root, root) %{_bindir}/mysql_tzinfo_to_sql
%attr(755, root, root) %{_bindir}/mysql_upgrade
%attr(755, root, root) %{_bindir}/mysql_zap
%attr(755, root, root) %{_bindir}/mysqlbug
%attr(755, root, root) %{_bindir}/mysqld_multi
%attr(755, root, root) %{_bindir}/mysqld_safe
%attr(755, root, root) %{_bindir}/mysqldumpslow
%attr(755, root, root) %{_bindir}/mysqlhotcopy
%attr(755, root, root) %{_bindir}/mysqltest
%attr(755, root, root) %{_bindir}/perror
%attr(755, root, root) %{_bindir}/replace
%attr(755, root, root) %{_bindir}/resolve_stack_dump
%attr(755, root, root) %{_bindir}/resolveip

%attr(755, root, root) %{_sbindir}/mysqld
%attr(755, root, root) %{_sbindir}/mysqlmanager
%attr(755, root, root) %{_sbindir}/rcmysql
%attr(644, root, root) %{_libdir}/mysql/mysqld.sym
%attr(755, root, root) %{_libdir}/mysql/plugin/

%attr(644, root, root) %config(noreplace,missingok) %{_sysconfdir}/logrotate.d/mysql
%attr(755, root, root) %{_sysconfdir}/init.d/mysql

%attr(755, root, root) %{_datadir}/mysql/

%files -n %{mysql_basename}-client
%defattr(-, root, root, 0755)
%attr(755, root, root) %{_bindir}/msql2mysql
%attr(755, root, root) %{_bindir}/mysql
%attr(755, root, root) %{_bindir}/mysql_find_rows
%attr(755, root, root) %{_bindir}/mysql_waitpid
%attr(755, root, root) %{_bindir}/mysqlaccess
%attr(755, root, root) %{_bindir}/mysqladmin
%attr(755, root, root) %{_bindir}/mysqlbinlog
%attr(755, root, root) %{_bindir}/mysqlcheck
%attr(755, root, root) %{_bindir}/mysqldump
%attr(755, root, root) %{_bindir}/mysqlimport
%attr(755, root, root) %{_bindir}/mysqlshow
%attr(755, root, root) %{_bindir}/mysqlslap

%doc %attr(644, root, man) %{_mandir}/man1/msql2mysql.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_find_rows.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_waitpid.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlaccess.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqladmin.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlbinlog.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlcheck.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqldump.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlimport.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlshow.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlslap.1*

%post -n %{mysql_basename}-shared
/sbin/ldconfig

%postun -n %{mysql_basename}-shared
/sbin/ldconfig

%files -n %{mysql_basename}-devel
%defattr(-, root, root, 0755)
%doc EXCEPTIONS-CLIENT
#%doc %attr(644, root, man) %{_mandir}/man1/comp_err.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_config.1*
#%attr(755, root, root) %{_bindir}/comp_err
%attr(755, root, root) %{_bindir}/mysql_config
%dir %attr(755, root, root) %{_libdir}/mysql
%{_includedir}/mysql
%{_datadir}/aclocal/mysql.m4
%{_libdir}/mysql/libdbug.a
%{_libdir}/mysql/libheap.a
%{_libdir}/mysql/libmy*.a
%{_libdir}/mysql/libmy*.la
%{_libdir}/mysql/libvio.a
%{_libdir}/mysql/libz*

%files -n %{mysql_basename}-shared
%defattr(-, root, root, 0755)
# Shared libraries (omit for architectures that don't support them)
%{_libdir}/*.so*


%files -n %{mysql_basename}-test
%defattr(-, root, root, 0755)
%{_datadir}/mysql-test
%attr(755, root, root) %{_bindir}/mysql_client_test
#%attr(755, root, root) %{_bindir}/mysqltestmanager
#%attr(755, root, root) %{_bindir}/mysqltestmanager-pwgen
#%attr(755, root, root) %{_bindir}/mysqltestmanagerc
%doc %attr(644, root, man) %{_mandir}/man1/mysql_client_test.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql-stress-test.pl.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql-test-run.pl.1*

# The spec file changelog only includes changes made to the spec file
# itself - note that they must be ordered by date (important when
# merging BK trees)
%changelog
* Fri Jan 08 2010 Kristian Nielsen <knielsen@knielsen-hq.org>

- Renaming to remove "ourdelta" from package names.

* Mon Nov 09 2009 Arjen Lentz <openquery.com>

- Compatibility tricks for libmysqlclient.so.15 (5.0 libs)
- more MariaDB-shared and other dep fixups

* Fri Oct 30 2009 Stephen Walsh <steve@nerdvana.org.au>

- change MariaDB-shared Provides/Requires to handle lp #463161

* Mon Oct 12 2009 Arjen Lentz <arjen@openquery.com>

- Adapt for MariaDB

* Tue May 19 2009 Toby Thain <toby@openquery.com>

- Adapt for 5.1

* Mon Oct 05 2008 Arjen Lentz <arjen@openquery.com>

- Pruned SPEC to start sorting out the mess
- Pruned changelog
