# Welcome to the OurDelta tarball bakery.
# 2008-11-01
# Peter Lieverdink <peter@openquery.com>
# Arjen Lentz <arjen@openquery.com>

# Utility func to test for required tools. Yes, I assume `which' is installed :-)
#
testbin () {
	BIN_PATH="$(which ${1})"
	if [ ! -x "${BIN_PATH}" -o -z "${BIN_PATH}" ]; then
		echo "Cannot find ${1}. Please install it into your \$PATH"
		return 1
	fi
	return 0
}

# Check that a directory exists.
testdir () {
	DIR_PATH="$(realpath ${1})"
	if [ ! -d "${DIR_PATH}" ]; then
		echo "Cannot find directory ${1}. Please create it"
		return 1
	fi
	return 0
}

# Setting cpu options.
get_cpuopt () {
	case "$(gcc -dumpmachine)" in
          x86_64-*)
                # gcc barfs on -march=... on x64
                CPUOPT="-m64 -mtune=generic"
                ;;
          *)
                # we'd use i586 to not trip up mobile/lowpower devices
                CPUOPT="-m32 -march=i586 -mtune=generic"
                ;;
	esac
	return 0
}
